## fann-2.0.0.tar.gz

=== benchmarks/Makefile ===
# The jneural library (http://voltar-confed.org/jneural/) and lwneuralnet library (http://sourceforge.net/projects/lwneuralnet/) needs to be installed in order to run the benchmarks

GCC = gcc
G++ = g++

TARGETS = quality quality_fixed performance performance_fixed shuffle parity two-spirals

CFLAGS = -O3 -finline-functions -funroll-loops -Werror

LFLAGS = -lm

JNEURALDIR = ../../libraries/jneural/

LWNNDIR = ../../libraries/lwneuralnet-0.6/source/

all: $(TARGETS)

quality: quality.cc
	$(G++) $(CFLAGS) $(LFLAGS) -I$(JNEURALDIR)include/ -L$(JNEURALDIR) -I$(LWNNDIR) -L$(LWNNDIR) $< -o $@ -lfloatfann -llwneuralnet -ljneural -lfl

quality_fixed: quality_fixed.c
	$(GCC) $(CFLAGS) $(LFLAGS) $< -o $@ -lfixedfann

quality_fixed_debug: quality_fixed.c
	$(GCC) -ggdb -lm -DDEBUG -Wall -ansi -I../src/ -I../src/include/ ../src/fixedfann.c $< -o $@

performance: performance.cc
	$(G++) $(CFLAGS) $(LFLAGS) -I$(JNEURALDIR)include/ -L$(JNEURALDIR) -I$(LWNNDIR) -L$(LWNNDIR) $< -o $@ -lfloatfann -llwneuralnet -ljneural -lfl

performance_fixed: performance.cc
	$(G++) $(CFLAGS) $(LFLAGS) -DFIXEDFANN $< -o $@ -lfixedfann

shuffle: shuffle.c
	$(GCC) $(CFLAGS) $(LFLAGS) $< -o $@ -lfloatfann

two-spirals: two-spirals.c
	$(GCC) $(CFLAGS) $(LFLAGS) $< -o $@

parity: parity.c
	$(GCC) $(CFLAGS) $(LFLAGS) $< -o $@

clean: 
	rm -rf -- $(TARGETS) *.net *fixed_test* *fixed_train* *~

distclean: clean
	rm -rf *.ps *.out

=== examples/Makefile ===
# This makefile is on purpose not made with configure, to show how to use the library
# The make file requires that the fann library is installed (see ../README)

GCC=gcc

TARGETS = xor_train xor_test xor_test_fixed simple_train steepness_train simple_test robot mushroom cascade_train
DEBUG_TARGETS = xor_train_debug xor_test_debug xor_test_fixed_debug cascade_train_debug

all: $(TARGETS)

%: %.c Makefile
	$(GCC) -O3 -lm -lfann $< -o $@

%_fixed: %.c Makefile
	$(GCC) -O3 -lm -lfixedfann -DFIXEDFANN $< -o $@

clean:
	rm -f $(TARGETS) $(DEBUG_TARGETS) xor_fixed.data *.net *~ *.obj *.exe *.tds

runtest: $(TARGETS)
	@echo
	@echo Training network
	./xor_train

	@echo
	@echo Testing network with floats
	./xor_test

	@echo
	@echo Testing network with fixed points
	./xor_test_fixed

#below this line is only for debugging the fann library

rundebugtest: $(DEBUG_TARGETS)
	@echo
	@echo Training network
	./xor_train_debug

	@echo
	@echo Testing network with floats
	./xor_test_debug

	@echo
	@echo Testing network with fixed points
	./xor_test_fixed_debug

runcompliancetest: $(DEBUG_TARGETS)
	./xor_train_debug

	@echo
	@echo Testing network with floats
	@cp xor_float.net xor_float_new.net
	@cp xor_float_backup.net xor_float.net
	@echo RUN
	@./xor_test_debug | grep XOR
	@echo CAT
	@cat xor_float_backup.out


#compiletest is used to test whether the library will compile easily in other compilers
compiletest:
	gcc -O3 -ggdb -lm -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c xor_train.c -o xor_train
	gcc -O3 -ggdb -lm -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -DFIXEDFANN -I../src/ -I../src/include/ ../src/fixedfann.c xor_test.c -o xor_test
	g++ -O3 -ggdb -lm -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c xor_train.c -o xor_train

quickcompiletest:
	gcc -O -ggdb -lm -DDEBUG -Wall -Wformat-security -Wfloat-equal -Wshadow -Wpointer-arith -Wcast-qual -Wsign-compare -pedantic -ansi -I../src/ -I../src/include/ ../src/floatfann.c ../examples/xor_train.c -o ../examples/xor_train

debug: $(DEBUG_TARGETS)

%_debug: %.c Makefile ../src/*c ../src/include/*h
	$(GCC) -ggdb -lm -DDEBUG -Wall -ansi -I../src/ -I../src/include/ ../src/floatfann.c $< -o $@

%_fixed_debug: %.c Makefile ../src/*c ../src/include/*h
	$(GCC) -ggdb -lm -DDEBUG -Wall -ansi -DFIXEDFANN -I../src/ -I../src/include/ ../src/fixedfann.c $< -o $@

rundebug: $(DEBUG_TARGETS)
	@echo
	@echo Training network
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_train_debug

	@echo
	@echo Testing network with floats
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_test_debug

	@echo
	@echo Testing network with fixed points
	valgrind --leak-check=yes --show-reachable=yes --leak-resolution=high --db-attach=yes ./xor_test_fixed_debug

=== python/Makefile ===
# This makefile was written to compile a distribution of pyfann for
# GNU platforms (cygwin included.)

ROOT=/
PYTHON=python

all: build

linux:
	@(cd pyfann && make)

clean:
	@(cd pyfann && make clean)
	@rm -fr dist build setup.pyc
	@rm -fr examples/{nets,pyfann/}

msvc:
	@(cd pyfann && make -f makefile.msvc)

build: ../src/fann.o
	@$(PYTHON) setup.py build

install: build
	@$(PYTHON) setup.py install --root $(ROOT)

../src/fann.o: ../Makefile
	@(cd .. && make )

../Makefile:
	@(cd .. && ./configure)

test: build
	@-mkdir examples/nets
	@$(PYTHON) setup.py install --install-lib examples 
	@cd examples && $(PYTHON) simple_train.py && $(PYTHON) mushroom.py

=== python/pyfann/Makefile ===
# This makefile was written to compile a distribution of pyfann for
# GNU platforms (cygwin included.)

TARGETS = _libfann.so

PYTHON=python2.4
FANN_DIR="../.."
LIBS=-L. -L/usr/local/lib -L/usr/bin -l$(PYTHON) $(FANN_DIR)/src/fann*.o

all: $(TARGETS)
	
_%.so: pyfann_wrap.o fann_helper.o
	gcc $(LIBS) -shared -dll $^ -o $@

%.o: %.c 
	gcc -c $< -I/usr/include/$(PYTHON)/ -I$(FANN_DIR)/src/include/

pyfann_wrap.c: pyfann.i 
	swig -python $<

clean:
	rm -f $(TARGETS) *_wrap.* fann_helper.o *.py{c,o} *.so libfann.*

=== debian/control ===
Source: libfann2
Section: libdevel
Priority: optional
Maintainer: Steffen Nissen <lukesky@diku.dk>
Standards-Version: 3.6.0
Build-Depends: docbook-utils, debhelper (>= 4.1.67), python-dev, swig

Package: libfann2-dev
Section: libdevel
Architecture: any
Depends: libfann2 (= ${Source-Version})
Description: Fast Artificial Neural Network Library 
 is a free open source neural network library, which implements multilayer 
 artificial neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. PHP, C++, .NET, Python, Delphi, Octave, Ruby,
 Pure Data and Mathematica bindings are available. A reference manual
 accompanies the library with examples and recommendations on how to
 use the library. A graphical user interface is also available for the
 library.
 .
 This package contains the header files and static libraries which is
 needed for developing the libfann applications.

Package: libfann2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Suggests: libfann2-dev (= ${Source-Version})
Description: Fast Artificial Neural Network Library 
 is a free open source neural network library, which implements multilayer 
 artificial neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. PHP, C++, .NET, Python, Delphi, Octave, Ruby,
 Pure Data and Mathematica bindings are available. A reference manual
 accompanies the library with examples and recommendations on how to
 use the library. A graphical user interface is also available for the
 library.
 . 
 This package contains the shared libraries.

Package: libfann2-py
Section: python
Architecture: any
Depends: ${shlibs:Depends}, libfann2, ${python:Depends}
Suggests: libfann2-dev (= ${Source-Version})
Description: Python FANN Bindings (pyfann)
 Fast Artificial Neural Network Library is a free open
 source neural network library, which implements multilayer artificial
 neural networks in C with support for both fully connected and
 sparsely connected networks. Cross-platform execution in both fixed
 and floating point are supported. It includes a framework for easy
 handling of training data sets. It is easy to use, versatile, well
 documented, and fast. PHP, C++, .NET, Python, Delphi, Octave, Ruby,
 Pure Data and Mathematica bindings are available. A reference manual
 accompanies the library with examples and recommendations on how to
 use the library. A graphical user interface is also available for the
 library.
 . 
 This package contains the python wrapper.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# shared library versions, option 1
version=2.0.0
major=2
# option 2, assuming the library is created as src/.libs/libfoo.so.2.0.5 or so
#version=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
#major=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

config.status: configure
	dh_testdir
	CFLAGS='$(CFLAGS)' ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info


build: build-stamp
build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	cd python && make build

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	-$(MAKE) distclean
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif


	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	( cd python && make install ROOT=$(CURDIR)/debian/tmp )

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_install --sourcedir=debian/tmp --list-missing
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
	dh_makeshlibs -V
	dh_python
	dh_installdeb
	dh_shlibdeps -L libfann
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
